VERSION 5.00
Begin VB.Form frmEditProperties 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Carrier - Level Editor [Properties]"
   ClientHeight    =   2730
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5625
   Icon            =   "EditProperties.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2730
   ScaleWidth      =   5625
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame fraGeneral 
      Caption         =   "Level Information"
      Height          =   1215
      Left            =   120
      TabIndex        =   9
      Top             =   120
      Width           =   5415
      Begin VB.TextBox txtOther 
         Height          =   375
         Left            =   1560
         TabIndex        =   1
         Top             =   720
         Width           =   3735
      End
      Begin VB.TextBox txtName 
         Height          =   375
         Left            =   1560
         TabIndex        =   0
         Text            =   "Untitled"
         Top             =   240
         Width           =   3735
      End
      Begin VB.Label lblOther 
         Caption         =   "Other Information:"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   840
         Width           =   1335
      End
      Begin VB.Label lblName 
         Caption         =   "Level Name:"
         Height          =   255
         Left            =   240
         TabIndex        =   10
         Top             =   360
         Width           =   1335
      End
   End
   Begin VB.Frame fraSize 
      Caption         =   "Level Size"
      Height          =   1215
      Left            =   120
      TabIndex        =   6
      Top             =   1440
      Width           =   3615
      Begin VB.TextBox txtHeight 
         Height          =   375
         Left            =   1560
         TabIndex        =   3
         Text            =   "8"
         Top             =   720
         Width           =   1815
      End
      Begin VB.TextBox txtWidth 
         Height          =   375
         Left            =   1560
         TabIndex        =   2
         Text            =   "9"
         Top             =   240
         Width           =   1815
      End
      Begin VB.Label lblHeight 
         Caption         =   "Height:"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   840
         Width           =   1335
      End
      Begin VB.Label lblWidth 
         Caption         =   "Width:"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   360
         Width           =   1335
      End
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   4200
      TabIndex        =   4
      Top             =   1800
      Width           =   1335
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   4200
      TabIndex        =   5
      Top             =   2280
      Width           =   1335
   End
End
Attribute VB_Name = "frmEditProperties"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Initialized As Boolean

'----------------------------------------------------------------
' Clear everything!!

Private Sub Form_Activate()
  Set ActiveForm = Me
  If Initialized Then Exit Sub
  txtName.SelStart = 0
  txtName.SelLength = Len(txtName.Text)
  txtWidth.SelStart = 0
  txtWidth.SelLength = Len(txtWidth.Text)
  txtHeight.SelStart = 0
  txtHeight.SelLength = Len(txtHeight.Text)
  txtName.SetFocus
  Initialized = True
End Sub

Private Sub Form_Load()
  frmEdit.CancelEditProp = False
End Sub


'----------------------------------------------------------------
' Load in the settings

Public Sub LoadSettings(IsNewLevel As Boolean)
  frmEdit.CancelEditProp = False
  txtName.Text = Game.PlayedLevel.Name
  txtOther.Text = Game.PlayedLevel.OtherInfo
  txtWidth.Text = Game.PlayedLevel.Width
  txtHeight.Text = Game.PlayedLevel.Height
  If IsNewLevel Then
    Me.Caption = "Carrier - Level Editor [New Level]"
  Else
    Me.Caption = "Carrier - Level Editor [Properties]"
  End If
End Sub


'----------------------------------------------------------------
' Button actions

Private Sub cmdOK_Click()
  Dim X As Integer
  Dim Y As Integer
  Dim NewFields() As Byte
  Dim OldWidth As Integer
  Dim OldHeight As Integer
  
  If txtName.Text = "" Then
    MsgBox "Please enter a name for this level!", vbExclamation
    txtName.SetFocus
    Exit Sub
  End If
  
  On Error Resume Next
    X = CInt(txtWidth.Text)
    X = CInt(txtHeight.Text)
    If Err.Number Then
      MsgBox "Please enter a number as field size!", vbExclamation
      Exit Sub
    End If
  On Error GoTo 0
  If txtWidth.Text < 5 Or txtHeight.Text < 5 Then
    MsgBox "The field dimensions need to be at least 5 x 5!", vbExclamation
    Exit Sub
  End If
  
  OldWidth = Game.PlayedLevel.Width
  OldHeight = Game.PlayedLevel.Height
  Game.PlayedLevel.Name = txtName.Text
  Game.PlayedLevel.OtherInfo = txtOther.Text
  Game.PlayedLevel.Width = txtWidth.Text
  Game.PlayedLevel.Height = txtHeight.Text
  
  ' Make new array, because ReDim Preserve can't redim everything.
  ReDim NewFields(0 To Game.PlayedLevel.Width - 1, 0 To Game.PlayedLevel.Height - 1) As Byte
  For X = 0 To Min(Game.PlayedLevel.Width, OldWidth) - 1
    For Y = 0 To Min(Game.PlayedLevel.Height, OldHeight) - 1
      NewFields(X, Y) = Game.PlayedLevel.Fields(X, Y)
    Next
  Next
  
  Game.PlayedLevel.Fields = NewFields
  Call frmEdit.RefreshAll
  Unload Me
End Sub

Private Sub cmdCancel_Click()
  frmEdit.CancelEditProp = True
  Unload Me
End Sub



'----------------------------------------------------------------
' Force numbers only!!

Private Sub txtHeight_KeyPress(KeyAscii As Integer)
  If Not KeyIsNumber(KeyAscii) Then
    KeyAscii = 0
    Beep
  End If
End Sub

Private Sub txtWidth_KeyPress(KeyAscii As Integer)
  If Not KeyIsNumber(KeyAscii) Then
    KeyAscii = 0
    Beep
  End If
End Sub
